/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// browse.cpp                                                              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.33 - 4 feb 1995                        //
// Author: H. Picot                                                        //
// Modified to use BDE/IDAPI SDK - Marco Cordeiro - Feb 26 1995            //                                                             //
/////////////////////////////////////////////////////////////////////////////


#include "griddll.h"
#pragma hdrstop
#include "bdebrows.h"
#include <errno.h>
#include <owl/opensave.h>

#define CHKERR(parm) DBIError(__FILE__, __LINE__, \
									 #parm, parm) ; \
									 if (GlobalDBIErr) { \
										 throw "BDE Error";}

// OwlMain
int OwlMain (int, char *[])
	{
	if (::MessageBox (0,
		"This program is a VERY crude file browser,\r\n"
		"whose sole purpose is to illustrate how to use\r\n"
		"TGrid in a dynamically created window.\r\n\n"
		"****** DON'T USE IT ON VALUABLE DATA ******",
		"!!! WARNING !!!",
		MB_ICONEXCLAMATION|MB_OKCANCEL|MB_DEFBUTTON2) == IDCANCEL)
		return 0;

	try {
		return Application().Run();
		}
	catch (char *s)
		{
		::MessageBox (0, s, "Dbf Browser", MB_ICONSTOP|MB_OK);
		}
	 catch (xmsg& x) {
		  ::MessageBox(0, x.why().c_str(), "Exception", MB_OK);
	 }
	 return -1;
	}


// class Application
Application::Application () : TApplication ()
	{
	}


void Application::InitMainWindow ()
	{
	EnableCtl3d (true);
	SetMainWindow (new TFrameWindow (0, "Dbf browser", new DbfBrowser ()));
	}


// class TGridStringField
class TGridStringField : public TGEdit
	{
	protected:
		void PerformCreate (int idOrMenu);

	public:
		TGridStringField (TWindow *p, int id, int w, int h, int fw);
	};

TGridStringField::TGridStringField (TWindow *p, int id, int w, int h, int fw)
		 : TGEdit (p, id, "", 0, 0, w, h, fw)
   {
   }

void TGridStringField::PerformCreate (int idOrMenu)
   {
   Attr.Style = ES_LEFT|ES_AUTOHSCROLL|WS_TABSTOP|WS_BORDER|WS_CHILD|ES_MULTILINE;
   TGEdit::PerformCreate (idOrMenu);
   }

// class TGridDateField
class TGridDateField : public TGDateEdit
	{
	protected:
		void PerformCreate (int idOrMenu);

	public:
		TGridDateField (TWindow *p, int id, int w, int h, string &fmt,
							 IntlDate &min, IntlDate &max);
	};


TGridDateField::TGridDateField (TWindow *p, int id, int w, int h,
										  string &fmt, IntlDate &min, IntlDate &max)
					  : TGDateEdit (p, id, 0, 0, w, h, fmt, min, max, false)
	{
	}

void TGridDateField::PerformCreate (int idOrMenu)
	{
	Attr.Style = ES_LEFT|ES_AUTOHSCROLL|WS_TABSTOP|WS_BORDER|WS_CHILD|ES_MULTILINE;
	TGEdit::PerformCreate (idOrMenu);
	}

// Class TGridTimeField
class TGridTimeField : public TGTimeEdit
	{
	protected:
		void PerformCreate (int idOrMenu);

	public:
		TGridTimeField (TWindow *p, int id, int w, int h, string &fmt,
							 TGTime &min, TGTime &max);
	};


void TGridTimeField::PerformCreate (int idOrMenu)
	{
	Attr.Style = ES_LEFT|ES_AUTOHSCROLL|WS_TABSTOP|WS_BORDER|WS_CHILD|ES_MULTILINE;
	TGEdit::PerformCreate (idOrMenu);
	}

TGridTimeField::TGridTimeField (TWindow *p, int id, int w, int h,
										  string &fmt, TGTime &min, TGTime &max)
					  : TGTimeEdit (p, id, 0, 0, w, h, fmt, min, max)
	{
	}


// class TGridNumericField
class TGridNumericField : public TGDoubleEdit
	{
	protected:
		void PerformCreate (int idOrMenu);

	public:
		TGridNumericField (TWindow *p, int id, int w, int h,
								 int width, int dec, double min, double max);
	};

TGridNumericField::TGridNumericField (TWindow *p, int id, int w, int h,
										  int width, int dec, double min, double max)
					  : TGDoubleEdit (p, id, 0.0, 0, 0, w, h, width, dec, min, max)
	{
	}

void TGridNumericField::PerformCreate (int idOrMenu)
	{
	Attr.Style = ES_RIGHT|ES_AUTOHSCROLL|WS_TABSTOP|WS_BORDER|WS_CHILD|ES_MULTILINE;
	TGEdit::PerformCreate (idOrMenu);
	}

// class TGridLongField
class TGridLongField : public TGLongEdit
	{
	protected:
		void PerformCreate (int idOrMenu);

	public:
		TGridLongField (TWindow *p, int id, int w, int h,
								 int width, long min, long max);
	};

TGridLongField::TGridLongField (TWindow *p, int id, int w, int h,
										  int width, long min, long max)
					: TGLongEdit (p, id, 0, 0, 0, w, h, width, min, max)
	{
	}

void TGridLongField::PerformCreate (int idOrMenu)
	{
	Attr.Style = ES_RIGHT|ES_AUTOHSCROLL|WS_TABSTOP|WS_BORDER|WS_CHILD|ES_MULTILINE;
	TGEdit::PerformCreate (idOrMenu);
	}

// class DbfBrowser
DEFINE_RESPONSE_TABLE1 (DbfBrowser, TWindow)
	EV_WM_WINDOWPOSCHANGED,
END_RESPONSE_TABLE;

DbfBrowser::DbfBrowser () : TWindow (0, 0, 0)
	{
	grid = new BrowserGrid (this);
	}


void DbfBrowser::EvWindowPosChanged (WINDOWPOS far &wpos)
	{
	TWindow::EvWindowPosChanged (wpos);
	TRect rc (GetClientRect ());
	grid->SetWindowPos (0, rc, SWP_NOZORDER);
	}


// class BrowserGrid
BrowserGrid::BrowserGrid (TWindow *p)
			  : TGrid (p, 100, 0, 0, 0, 0,
						  TGrid::NextLine,
						  TGrid::TabNextColumn,
						  TGrid::ReverseColor,
						  -1,
						  TGrid::gAllBorders
						| TGrid::gHideHScroll
						| TGrid::gCenterTitle
						| TGrid::gLineSwapOn
						| TGrid::gSizeColumn )
	{
	 hCur = 0;
	 hDb = 0;
	 fields = 0;
	 pFldDesc =0;
	 pRecBuf = 0;

	// initializes IDAPI
	CHKERR(DbiInit(NULL));
	// Opens a Standard database (used to access Paradox, dBASE, and Text
	//   tables), by using a NULL database type.
	CHKERR(DbiOpenDatabase(NULL, NULL, dbiREADWRITE, dbiOPENSHARED,
								  NULL, 0, NULL, NULL, &hDb));

	// Selects the table
	char accTables[256];
	ostrstream os(accTables, sizeof accTables);
	os << "DBF files (*.dbf)|*.DBF"
		<< "|Paradox files (*.db)|*.DB"
		<< "|All files (*.*)|*.*|"
		<< ends;
	TOpenSaveDialog::TData data (OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,
										  accTables, 0, 0, "DBF");

	TFileOpenDialog *fod = new TFileOpenDialog
		  (GetApplication()->GetMainWindow(), data, 0, "Sample table browser");
	if (fod->DoExecute () != IDOK)
		throw "file selection aborted";
	delete fod;

	// Attemps to open the select file as database table
	char szTblType[] = "";
	CHKERR(DbiOpenTable(hDb,                 // Handle to the database of the
														  //   table Paradox and dBASE use
														  //   the standard database
								data.FileName,      // Name of the table
								szTblType,          // Type of the table - not needed
								NULL,               // Index name
								NULL,               // Index tag name
								NULL,               // Index ID
								dbiREADWRITE,       // Open the table for both reading
														  //   and writing
								dbiOPENSHARED,      // Open the table in shared mode -
								xltFIELD,           // Field values are translated from
														  //   internal types to logical
														  //   types usable in the
														  //   application
								FALSE,              // Unidirectional - Yes, No
								NULL,               // Optional parameters
								&hCur));            // Cursor handle to the table

	InitFields ();

	for (int i = 0; i < nfields; i++)
		Add (fields[i].ctrl, fields[i].name, fields[i].align);

	SetVBarText (8);  // make vbar 8 char wide, text is user-defined
	}


void BrowserGrid::CalcPos ()
	{
	TGrid::CalcPos ();
	}
   

BrowserGrid::~BrowserGrid ()
   {
	 if (hCur)
		CHKERR(DbiCloseCursor(&hCur));  // Closes table
	 if (hDb)
		CHKERR(DbiCloseDatabase(&hDb)); // Closes the database.
	 CHKERR(DbiExit());              //  Exits IDAPI
	 if (fields)
		 delete[] fields;
	 if (pFldDesc)
		delete[] pFldDesc;
	 if (pRecBuf)
		delete[] pRecBuf;
	}


const void *BrowserGrid::TransferItem (int line, int id)
   {
	if ((unsigned)line >= (unsigned)nrec || id > nfields)
		return 0;

	// line sequence
	if (id == 0) {
		static char seq[6];
		sprintf(seq, "%d ", line + 1);
		return static_cast<void *>(seq);
	}

	// Reads a new record when needed
	if (line != currLine) {
	  RECProps recProps;
	  CHKERR(DbiGetRelativeRecord(hCur, (line - currLine), dbiNOLOCK,
								 pRecBuf, &recProps));
	  currLine = line;
	}

	// auxiliary fields
	Field &fld = fields[id - 1];
	BOOL blank;                         // NULL flag
	static char buffer[sizeof pRecBuf]; // return buffer
	memset (buffer, NULL, sizeof(buffer));

	switch (fld.type)
		{
		case fldBLOB:
			strcpy(buffer, "<BLOB>");
			break;
		case fldstMEMO:
		case fldstFMTMEMO:
		case fldPDXMEMO:
			strcpy(buffer, "<MEMO>");
			break;
		case fldstBINARY:
		case fldstTYPEDBINARY:
		case fldBYTES:
			strcpy(buffer, "<BYNARY>");
			break;
		case fldstOLEOBJ:
		case fldstDBSOLEOBJ:
			strcpy(buffer, "<OLE OBJ>");
			break;
		case fldstGRAPHIC:
			strcpy(buffer, "<GRAPHIC>");
			break;
		case fldDATE:
			{
			CHKERR(DbiGetField(hCur, id, pRecBuf, (pBYTE) buffer, &blank));
			UINT16 uDay = 0;                   // Day part of the date
			UINT16 uMonth = 0;                 // Month part of the date
			INT16  iYear = 0;                  // Year part of the date
			CHKERR(DbiDateDecode(*(DATE *)buffer, &uMonth, &uDay, &iYear));
			IntlDate* pgdate = new IntlDate(uDay, uMonth, iYear);
			memcpy (buffer, pgdate, sizeof(*pgdate));
			delete pgdate;
			break;
			}
		case fldTIME:
			{
			CHKERR(DbiGetField(hCur, id, pRecBuf, (pBYTE) buffer, &blank));
			UINT16 uHour = 0;                  // Hour part of the time
			UINT16 uMin = 0;                   // Min Part of the time
			UINT16 uMilSec = 0;                // Milliseconds (seconds included)
			UINT16 uSec = 0;                   // To be extracted from milliseconds
			CHKERR(DbiTimeDecode(*(TIME *)buffer, &uHour, &uMin, &uMilSec));
			uSec = uMilSec / 1000;
			uMilSec -= uSec / 1000;
			TGTime* pgtime = new TGTime((int) uHour, uMin, uSec, uMilSec);
			memcpy (buffer, pgtime, sizeof(*pgtime));
			delete pgtime;
			break;
			}
		case fldINT16:
			{
			INT16 iVal;
			CHKERR(DbiGetField(hCur, id, pRecBuf, (pBYTE) &iVal, &blank));
			INT32 lVal = iVal;
			memcpy (buffer, &lVal, sizeof(lVal));
			break;
			}
		case fldBOOL:
			{
			BOOL bVal = 0;                // Logical fields
			CHKERR(DbiGetField(hCur, id, pRecBuf, (pBYTE) &bVal, &blank));
			INT32 lVal = bVal;
			memcpy (buffer, &lVal, sizeof(lVal));
			break;
			}
		default:
			CHKERR(DbiGetField(hCur, id, pRecBuf, (pBYTE) buffer, &blank));
			break;
		}

	return static_cast<void *>(buffer);
	}


void BrowserGrid::TransferItem (int line, int id, const void *data)
	{
	 if (id && data)
	 {
	  // reads a new record
	  if (line != currLine) {
		RECProps recProps;
		CHKERR(DbiGetRelativeRecord(hCur, (line - currLine), dbiNOLOCK,
								 pRecBuf, &recProps));
		currLine = line;
	  }
	  // Auxiliary field
	  Field &fld = fields[id - 1];

	  switch (fld.type)
		{
		case fldBLOB:
		case fldstMEMO:
		case fldstFMTMEMO:
		case fldPDXMEMO:
		case fldstBINARY:
		case fldstTYPEDBINARY:
		case fldBYTES:
		case fldstOLEOBJ:
		case fldstDBSOLEOBJ:
		case fldstGRAPHIC:
			break;
		case fldDATE:
			{
			IntlDate tdate = *static_cast<const IntlDate *>(data);
			DATE fdate;
			CHKERR(DbiDateEncode(tdate.GetMonth(), tdate.GetDay(),
										 tdate.GetYear(), &fdate));
			CHKERR(DbiPutField(hCur, id, pRecBuf, (pBYTE) &fdate));
			break;
			}
		case fldTIME:
			{
			TGTime ttime = *static_cast<const TGTime *>(data);
			TIME ftime;
			CHKERR(DbiTimeEncode(ttime.GetHour(), ttime.GetMinute(),
						 ttime.GetSecond() * 1000 + ttime.GetMillisec(), &ftime));
			CHKERR(DbiPutField(hCur, id, pRecBuf, (pBYTE) &ftime));
			break;
			}
		case fldINT16:
			{
			INT32 lVal = *static_cast<const INT32 *>(data);
			INT16 iVal = lVal;
			CHKERR(DbiPutField(hCur, id, pRecBuf, (pBYTE) &iVal));
			break;
			}
		case fldBOOL:
			{
			INT32 lVal = *static_cast<const INT32 *>(data);
			BOOL bVal = lVal;
			CHKERR(DbiPutField(hCur, id, pRecBuf, (pBYTE) &bVal));
			break;
			}
		default:
			CHKERR(DbiPutField(hCur, id, pRecBuf, (pBYTE) data));
			break;
		}
		// Updates record
		CHKERR(DbiModifyRecord(hCur, pRecBuf, TRUE));
	  }
	}

void BrowserGrid::InitFields ()
	{
	// gets the table properties
	CHKERR(DbiGetCursorProps(hCur, &curProps));
	
	// Allocates the record buffer
	pRecBuf = new BYTE[curProps.iRecBufSize];

	// Allocates and gets an array of field descriptors
   nfields = curProps.iFields;
	pFldDesc = new FLDDesc[nfields];
	CHKERR(DbiGetFieldDescs(hCur, pFldDesc));

	// Gets number of records
	for(nrec = 0;
	 DbiGetNextRecord(hCur, dbiNOLOCK, pRecBuf, NULL) == DBIERR_NONE; nrec++);
	if (nrec == 0)
		throw "Table is empty";
	CHKERR(DbiSetToBegin(hCur));
	CHKERR(DbiGetNextRecord(hCur, dbiNOLOCK, pRecBuf, NULL));
   currLine = 0;
	// Grid columns
	fields = new Field[nfields];

   int w = LOWORD(GetDialogBaseUnits());
	int h = HIWORD(GetDialogBaseUnits()) + 5;

	// Date format and limits
	string datefmt = GetLanguage().SysShortDate ();
	IntlDate min (1,1,1750);
	IntlDate max (31,12,9999);

	// Time format and limits
	string timefmt = "HH:MM:SS.sss";
	TGTime timemin(0,0,0,0);
	TGTime timemax(23,59,59,999);

	for (int i = 0; i < nfields; i++)
		{
		Field &fld = fields[i];
		strcpy (fld.name, pFldDesc[i].szName);
		fld.type = pFldDesc[i].iFldType;
		fld.width = pFldDesc[i].iUnits1;
		fld.decimals = pFldDesc[i].iUnits2;
		fld.align = TGrid::Left;

		unsigned char width = fld.width;
		int l = strlen(fld.name);
		if (width < l)
			width = (short)l;

		int cx = ((width*w*4)/3)+5;   // average width
		int id = 1 + i;
		switch (fld.type)
			{
			case fldBLOB:
			case fldstMEMO:
			case fldstFMTMEMO:
			case fldPDXMEMO:
			case fldstBINARY:
			case fldstTYPEDBINARY:
			case fldBYTES:
			case fldstOLEOBJ:
			case fldstDBSOLEOBJ:
			case fldstGRAPHIC:
				fld.ctrl = new TGStatic
				  (this, id, "", 0, 0, cx, h, l < 11 ? 11 : l );
				break;

			case fldDATE:
				fld.ctrl = new TGridDateField (this, id, cx, h, datefmt,
														  min, max);
				break;

			case fldFLOAT:
			{
				// Paradox type NUMBER is translated to logical type fldFLOAT
				// w/ width = 1, decimals = 0
				if (fld.width == 1)
					 fld.width = 20;
				double fmin, fmax;
				char buffer[255];
				memset (buffer, '9', fld.width+2);
				buffer[0] = '0';
				if (fld.decimals) {
					buffer[fld.width-fld.decimals-1] = '.';
					buffer[fld.width+2] = '\0';
				}
				else
					buffer[fld.width+1] = '\0';
				fmax = atof(buffer);
				buffer[0] = '-';
				fmin = atof(buffer);
				fld.ctrl = new TGridNumericField (this, id, cx, h, fld.width,
												  fld.decimals, fmin, fmax);
				fld.align = TGrid::Right;
				break;
			}
			case fldINT16:
			case fldINT32:
				{
				long lmin, lmax;
				char buffer[255];
				memset (buffer, '9', fld.width+1);
				buffer[0] = '0';
				buffer[fld.width+1] = '\0';
				lmax = atol(buffer);
				buffer[0] = '-';
				lmin = atol(buffer);
				fld.ctrl = new TGridLongField (this, id, cx, h, fld.width,
												  lmin, lmax);
				fld.align = TGrid::Right;
				break;
				}

			case fldTIME:
				fld.ctrl = new TGridTimeField (this, id, cx, h,
														 timefmt, timemin, timemax);
				break;

			case fldBOOL:
				fld.ctrl = new TGridLongField (this, id, cx, h, 1, 0, 1);
				fld.align = TGrid::Right;
				break;

			default:
				fld.ctrl = new TGridStringField (this, id, cx, h, fld.width+1);
				break;
			}
		}
	}

bool BrowserGrid::AppendNewLine (int &newline)
	{
	if ((unsigned)newline >= (unsigned)nrec)
		return false;
	else
		return true;
	}

//====================================================================
//          This function takes in the information of where
//          the error occurred and displays it as a message box.
//====================================================================
DBIResult
BrowserGrid::DBIError (pCHAR module, UINT16 line, pCHAR function, DBIResult retVal)
{
	 DBIErrInfo  ErrInfo;
	 char szDBIStatus[(DBIMAXMSGLEN * 7)+1];
	 // Leave space for the extra messages.
	 char szMessage[(DBIMAXMSGLEN * 7)+1+110];

	 if (retVal == DBIERR_NONE)
	 {
		  GlobalDBIErr = DBIERR_NONE;
		  return retVal;
	 }
	 if (retVal != DBIERR_CANTFINDODAPI)
	 {
		  // Get as much error information as possible
		  DbiGetErrorInfo(TRUE, &ErrInfo);

		  // Make certain information is returned on the correct error
		  if (ErrInfo.iError == retVal)
		  {
				strcpy(szDBIStatus, ErrInfo.szErrCode);

				if (strcmp(ErrInfo.szContext1, ""))
				{
					 strcat(szDBIStatus, ErrInfo.szContext1);
				}
				if (strcmp(ErrInfo.szContext2, ""))
				{
					 strcat(szDBIStatus, ErrInfo.szContext2);
				}
				if (strcmp(ErrInfo.szContext3, ""))
				{
					 strcat(szDBIStatus, ErrInfo.szContext3);
				}
				if (strcmp(ErrInfo.szContext4, ""))
				{
					 strcat(szDBIStatus, ErrInfo.szContext4);
				}
		  }
		  else {
				DbiGetErrorString(retVal, szDBIStatus);
		  }

		  sprintf(szMessage, "Module:\t\t%s\nFunction:\t%s\nLine:\t\t%d\n"
					 "Category:\t%d\nCode:\t\t%d\nError:\r\n\r\n%s", module,
					 function, line, ErrCat(retVal), ErrCode(retVal),
					 szDBIStatus);

		  MessageBox(szMessage, "BDE/IDAPI Error",
						 MB_ICONEXCLAMATION | MB_OK);

			 }
	 else
	 {
		  MessageBox("Cannot find IDAPI files: Check path.",
						 "IDAPI Initialization Error", MB_ICONHAND | MB_OK);
	 }
	 GlobalDBIErr = retVal;
	 return retVal;
}
// EOF




