/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// browse.h                                                                //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.33 - 4 feb 1995                        //
// Author: H. Picot                                                        //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
#include <idapi.h>

// class Application                                                        *
class Application : public TApplication
   {
   public:
      Application();
      void InitMainWindow ();
	};

class Field
   {
   public:
      Field() {decimals = 0;}
		char name[32];
		char type;
      int  width;
		int  decimals;
      TControl *ctrl;
		TGrid::Align align;
	};

class BrowserGrid : public TGrid
   {
	protected:
		DBIResult  rslt;       // Return value from IDAPI functions
		hDBIDb     hDb;        // Handle to the database
		hDBICur    hCur;       // Handle to the table
		CURProps   curProps;   // cursor properties
		pBYTE      pRecBuf;    // pointer to the record buffer
		pFLDDesc   pFldDesc;   // ponter to the array of field descriptors
		Field *fields;
		int nfields;
		long nrec;
		long currLine;
		virtual const void *TransferItem (int line, int id);
      virtual void TransferItem (int line, int id, const void *data);
      virtual bool AppendNewLine (int &newline);
      void InitFields ();
      void CalcPos ();
		DBIResult DBIError(pCHAR, UINT16, pCHAR, DBIResult);
	   DBIResult GlobalDBIErr;

   public:
      BrowserGrid (TWindow *p);
     ~BrowserGrid ();
   };


class DbfBrowser : public TWindow
   {
   protected:
      BrowserGrid *grid;
      void EvWindowPosChanged (WINDOWPOS far &wpos);

   public:
      DbfBrowser ();
      DECLARE_RESPONSE_TABLE (DbfBrowser);
   };

// EOF

