/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// browse.h                                                                //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.34 - 11 mar 1995                       //
// Author: H. Picot                                                        //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

// class Application                                                        *
class Application : public TApplication
   {
   public:
      Application();
      void InitMainWindow ();
   };

class Field
   {
   public:
      char name[11];   // dbf field names are 10 chars long max.
      char type;
      int  width;
      int  decimals;
      int  offset;
      TControl *ctrl;
      TGrid::Align align;
   };

class BrowserGrid : public TGrid
   {
   protected:
      FILE *fd;
      Field *fields;
      int nfields;
      short offset;
      short size;
      long nrec;

      virtual const void *TransferItem (int line, int id);
      virtual void TransferItem (int line, int id, const void *data);
      virtual bool AppendNewLine (int &newline);
      long InitFields ();
      void CalcPos ();

   public:
      BrowserGrid (TWindow *p);
     ~BrowserGrid ();
   };


class DbfBrowser : public TWindow
   {
   protected:
      BrowserGrid *grid;
      void EvWindowPosChanged (WINDOWPOS far &wpos);

   public:
      DbfBrowser ();
      DECLARE_RESPONSE_TABLE (DbfBrowser);
   };

// EOF

