/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// gridbtn.h                                                               //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.34 - 11 mar 1995                       //
// Author: H. Picot                                                        //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#ifndef GRIDBTN_H
#define GRIDBTN_H

class _GRIDCLASS TGButton : public TButton
   {
   friend TGrid;

   MOUSE_HANDLER_HEADER

   protected:
      TGrid *grid;

      virtual void DrawCell (TDC &dc, TRect &rc, const void *p, TGrid::Align align = TGrid::Left); 
      virtual void EvChar (uint key, uint repeat, uint flags); 
      virtual uint EvGetDlgCode (MSG far *msg);
      virtual void EvKeyDown (uint key, uint repeat, uint flags);
      virtual void EvKeyUp (uint key, uint repeat, uint flags);
      virtual void EvKillFocus (HWND hWndGetFocus);                     
      virtual void EvSetFocus (HWND hWndLostFocus);
      virtual bool PreProcessMsg (MSG &msg);

   public:
      TGButton (TWindow *p, int id, TModule *module = 0);
      TGButton (TWindow *p, int id, char *text, int x, int y, int w, int h, bool isdefault = false, TModule *module = 0);

      virtual int Height () { return Attr.H; }     
      virtual int  Width () { return Attr.W; }     

      DECLARE_RESPONSE_TABLE (TGButton);
   };
 
#endif

// EOF
