/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// gridcbox.h                                                              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.34 - 11 mar 1995                       //
// Author: H. Picot                                                        //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////


#ifndef GRIDCBOX_H
#define GRIDCBOX_H

class _GRIDCLASS TGComboBox : public TComboBox
   {
   friend TGrid;
   friend TGrid::Column;

   COLOR_HEADER
   MOUSE_HANDLER_HEADER

   protected:
      TColor activeBG;
      TColor selectedFG;
      TGrid *grid;
      int oldsel;
      string oldstr;
      TColor columnbkg;
      int totalHeight;

      TColor ColumnBkg () { return columnbkg; }                      

      virtual void CbnSetFocus   ();
      virtual void CbnKillFocus  ();
      virtual void DrawCBItem    (DRAWITEMSTRUCT &info);
      virtual void DrawCell      (TDC &dc, TRect &rc, const void *p,
                                  TGrid::Align align = TGrid::Left);
      virtual void EvChar        (uint key, uint repeat, uint flags);
      virtual HBRUSH EvCtlColor  (HDC hDC, HWND hWndChild, uint);
      virtual uint EvGetDlgCode  (MSG far *msg);
      virtual void EvKeyDown     (uint key, uint repeat, uint flags);
      virtual void EvKeyUp       (uint key, uint repeat, uint flags);
      virtual void EvKillFocus   (HWND hWndGetFocus);
      virtual void EvSetFocus    (HWND hWndLostFocus);
      virtual void *GetData      ();
      virtual void Init          ();
      virtual void InitDraw      (DRAWITEMSTRUCT &info, TDC &dc, char * &p, TRect &rect);
      virtual void MeasureItem   (MEASUREITEMSTRUCT &info);
      virtual void ODADrawEntire (DRAWITEMSTRUCT &info);
      virtual void ODASelect     (DRAWITEMSTRUCT &info);
      virtual bool PreProcessMsg (MSG &msg);
      virtual void SetData       (void *);
      virtual void SetupWindow   ();

   public:
      TGComboBox (TWindow *p, int resid, uint textlen = 0, TModule *module = 0);
      TGComboBox (TWindow *p, int resid, int x, int y, int w, int h,
                  DWORD style, uint textlen = 0, TModule *module = 0);
     ~TGComboBox ();

      virtual int Height ();
      virtual int Width  () { return Attr.W; }
      void SetColors     (TColor t, TColor b, TColor a);
      bool IsModified    ();

      DECLARE_RESPONSE_TABLE (TGComboBox);
   };

#endif

// EOF
