/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// gridckbx.h                                                              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.34 - 11 mar 1995                       //
// Author: H. Picot                                                        //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////


#ifndef GRIDCKBX_H
#define GRIDCKBX_H

class _GRIDCLASS TGCheckBox : public TCheckBox
   {
   friend TGrid;

   COLOR_HEADER
   MOUSE_HANDLER_HEADER

   protected:
      TGrid *grid;
      int oldstate;
      bool bwcc;

      virtual void DrawCell (TDC &dc, TRect &rc, const void *p,
                             TGrid::Align align = TGrid::Left);
      virtual void EvChar (uint key, uint repeat, uint flags);
      virtual uint EvGetDlgCode (MSG far *msg);
      virtual void EvKeyDown (uint key, uint repeat, uint flags);
      virtual void EvKeyUp (uint key, uint repeat, uint flags);
      virtual void EvKillFocus (HWND hWndGetFocus);
      virtual void EvSetFocus (HWND hWndLostFocus);
      virtual void Init ();
      virtual bool PreProcessMsg (MSG &msg);

   public:
      TGCheckBox (TWindow *p, uint id, TGroupBox *group =0,
                  TModule *module =0);
      TGCheckBox (TWindow *p, uint id, char *title, int x, int y, int w, int h,
                  TGroupBox *group =0, TModule *module =0);
     ~TGCheckBox ();

      void SetBwcc (bool flag) { bwcc = flag; }

      virtual int Height () { return Attr.H; }  
      virtual int  Width () { return Attr.W; }  

      DECLARE_RESPONSE_TABLE (TGCheckBox);
   };

#endif

// EOF
