/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// gridstat.cpp                                                            //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.34 - 11 mar 1995                       //
// Author: H. Picot                                                        //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#include "griddll.h"

TGStatic::TGStatic (TWindow *p, int id, int textlen, TModule *module)
        : TStatic (p, id, textlen, module)
   {
   Init ();
   }


TGStatic::TGStatic (TWindow *p, int id, char *title, int x, int y, int w, int h, int textlen, TModule *module)
        : TStatic (p, id, title, x, y, w, h, textlen, module)
   {
   Init ();
   }


void TGStatic::Init ()
   {
   grid = 0;
   bool bwcc = GetApplication()->BWCCEnabled ();
   bkg = bwcc ? TColor::LtGray : TColor(GetSysColor (COLOR_WINDOW));
   text  = bwcc ? TColor::Black : TColor(GetSysColor (COLOR_WINDOWTEXT));
   brush = new TBrush (bkg);      
   }


TGStatic::~TGStatic ()
   {
   delete brush;
   }


COLOR_CODE(TGStatic)


void TGStatic::DrawCell (TDC &dc, TRect &rc,const void *p,TGrid::Align align)
   {
   TColor bg, fg;
   HBRUSH dummy;

   int line = grid->GetDataLine (rc.top);
   int id = GetId ();

   if (grid->LineSelected (line))
      {
      fg = grid->hilitetext;
      bg = grid->hilite;
      }
   else
      {
      bool customColors = grid->CellColor (line, id, false, bg, fg, dummy);
      if (!customColors)
         {
         fg = text;
         bg = bkg;
         }
      }

   dc.SetTextColor (fg);
   dc.SetBkColor   (bg);
   dc.FillRect (rc, TBrush(bg));

   rc.Inflate (-1, -1);

   if (p && *static_cast<const char *>(p))
      dc.DrawText (static_cast<const char *>(p), -1, rc,
                   (WORD)(align|DT_NOPREFIX|DT_WORDBREAK));
   }

// EOF
